#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#define MYPORT 3490
#define BACKLOG 10

int main(void)
{
    int sockfd, new_fd;
    struct sockaddr_in my_addr;
    struct sockaddr_in their_addr;
    int sin_size, sr;
    char input;


    if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
        perror("socket");
        exit(1);
    }

    my_addr.sin_family = AF_INET;
    my_addr.sin_port = htons(MYPORT);
    my_addr.sin_addr.s_addr = INADDR_ANY;
    memset(&(my_addr.sin_zero), '\0', 8);

    if (bind(sockfd, (struct sockaddr *)&my_addr, 
	     sizeof(struct sockaddr)) == -1) {
        perror("bind");
        exit(1);
    }

    if (listen(sockfd, BACKLOG) == -1) {
        perror("listen");
        exit(1);
    }


    while(1) {  // main accept() loop
        sin_size = sizeof(struct sockaddr_in);
        if ((new_fd = accept(sockfd, 
			     (struct sockaddr *)&their_addr,
			     &sin_size)) == -1) {
            perror("accept");
            continue;
        }
        printf("server: got connection from %s\n",
	       inet_ntoa(their_addr.sin_addr));

	while (1) {

	  int recvd = recv( new_fd, &input, 1, 0 );
	  if ( recvd == -1 )
	    {
	      perror( "recv" );
	      break;
	    }
	  else if ( recvd == 0 )
	    {
	      printf( "closing connection!\n" );
	      break;
	    }

	  if ( send( new_fd, &input, 1, 0 ) == -1 )
	    {
	      perror( "send" );
	      break;
	    }
	}

	close(new_fd);
    }
    return 0;
}
	

/* author: Gustavo Sverzut Barbieri (http://www.gustavobarbieri.com.br) */
