/* fs.x: file server using RPC */

%#define MAX_FILENAME_SIZE  255
%#define MAX_BLOCK_SIZE    8192

struct fs_get_ret_t 
{
  int    status;
  opaque buffer< MAX_BLOCK_SIZE >;
};

struct fs_get_param_t
{
  long   offset;
  long   count;
  string name< MAX_FILENAME_SIZE >;
};

struct fs_list_t
{
  int    status;
  long   offset;
  string name< MAX_FILENAME_SIZE >;
};



program FSPROG 
{
  version FSVERS 
    {
      string       CRED()                = 1;

      fs_get_ret_t GET( fs_get_param_t ) = 2;

      fs_list_t    LIST( fs_list_t )     = 3;

      int          EXIST( string )       = 4;

    } = 1;
} = 0x20000001;
